// This file was automatically generated. Do not edit this file!
#ifndef INITIALIZER_EXOTICA_CORE_COLLISION_SCENE_INITIALIZER_H
#define INITIALIZER_EXOTICA_CORE_COLLISION_SCENE_INITIALIZER_H

#include <exotica_core/property.h>

namespace exotica
{
inline std::vector<Initializer> GetExoticaCoreInitializers();
}

namespace exotica
{

class CollisionSceneInitializer : public InitializerBase
{
public:
    static std::string GetContainerName() { return "exotica/CollisionScene"; }

    CollisionSceneInitializer() : InitializerBase(),
        Debug( false) ,
        ReplacePrimitiveShapesWithMeshes( false) ,
        ReplaceCylindersWithCapsules( false) ,
        WorldLinkScale( 1.0) ,
        RobotLinkScale( 1.0) ,
        WorldLinkPadding( 0.0) ,
        RobotLinkPadding( 0.0) ,
        RobotLinkReplacementConfig( "") 
    {
    }

    CollisionSceneInitializer( std::string _Name, bool _Debug =  false, bool _ReplacePrimitiveShapesWithMeshes =  false, bool _ReplaceCylindersWithCapsules =  false, double _WorldLinkScale =  1.0, double _RobotLinkScale =  1.0, double _WorldLinkPadding =  0.0, double _RobotLinkPadding =  0.0, std::string _RobotLinkReplacementConfig =  "") : InitializerBase(),
        Name(_Name) ,
        Debug(_Debug) ,
        ReplacePrimitiveShapesWithMeshes(_ReplacePrimitiveShapesWithMeshes) ,
        ReplaceCylindersWithCapsules(_ReplaceCylindersWithCapsules) ,
        WorldLinkScale(_WorldLinkScale) ,
        RobotLinkScale(_RobotLinkScale) ,
        WorldLinkPadding(_WorldLinkPadding) ,
        RobotLinkPadding(_RobotLinkPadding) ,
        RobotLinkReplacementConfig(_RobotLinkReplacementConfig) 
    {
    }

    CollisionSceneInitializer(const Initializer& other) : CollisionSceneInitializer()
    {
        if (other.HasProperty("Name")) { const Property& prop = other.properties_.at("Name"); if(prop.IsSet()) {Name = boost::any_cast<std::string>(prop.Get());} }
        if (other.HasProperty("Debug")) { const Property& prop = other.properties_.at("Debug"); if(prop.IsSet()) {Debug = prop.IsStringType()?ParseBool(boost::any_cast<std::string>(prop.Get())):boost::any_cast<bool>(prop.Get());} }
        if (other.HasProperty("ReplacePrimitiveShapesWithMeshes")) { const Property& prop = other.properties_.at("ReplacePrimitiveShapesWithMeshes"); if(prop.IsSet()) {ReplacePrimitiveShapesWithMeshes = prop.IsStringType()?ParseBool(boost::any_cast<std::string>(prop.Get())):boost::any_cast<bool>(prop.Get());} }
        if (other.HasProperty("ReplaceCylindersWithCapsules")) { const Property& prop = other.properties_.at("ReplaceCylindersWithCapsules"); if(prop.IsSet()) {ReplaceCylindersWithCapsules = prop.IsStringType()?ParseBool(boost::any_cast<std::string>(prop.Get())):boost::any_cast<bool>(prop.Get());} }
        if (other.HasProperty("WorldLinkScale")) { const Property& prop = other.properties_.at("WorldLinkScale"); if(prop.IsSet()) {WorldLinkScale = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("RobotLinkScale")) { const Property& prop = other.properties_.at("RobotLinkScale"); if(prop.IsSet()) {RobotLinkScale = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("WorldLinkPadding")) { const Property& prop = other.properties_.at("WorldLinkPadding"); if(prop.IsSet()) {WorldLinkPadding = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("RobotLinkPadding")) { const Property& prop = other.properties_.at("RobotLinkPadding"); if(prop.IsSet()) {RobotLinkPadding = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("RobotLinkReplacementConfig")) { const Property& prop = other.properties_.at("RobotLinkReplacementConfig"); if(prop.IsSet()) {RobotLinkReplacementConfig = boost::any_cast<std::string>(prop.Get());} }
    }

    virtual ~CollisionSceneInitializer()
    {
    }

    virtual Initializer GetTemplate() const
    {
        return (Initializer)CollisionSceneInitializer();
    }

    virtual std::vector<Initializer> GetAllTemplates() const
    {
        return GetExoticaCoreInitializers();
    }

    virtual void Check(const Initializer& other) const
    {
        if(!other.HasProperty("Name") || !other.properties_.at("Name").IsSet()) ThrowPretty("Initializer CollisionSceneInitializer requires property Name to be set!");
    }

    operator Initializer()
    {
        Initializer ret(GetContainerName());
        ret.properties_.emplace("Name", Property("Name", true, boost::any(Name)));
        ret.properties_.emplace("Debug", Property("Debug", false, boost::any(Debug)));
        ret.properties_.emplace("ReplacePrimitiveShapesWithMeshes", Property("ReplacePrimitiveShapesWithMeshes", false, boost::any(ReplacePrimitiveShapesWithMeshes)));
        ret.properties_.emplace("ReplaceCylindersWithCapsules", Property("ReplaceCylindersWithCapsules", false, boost::any(ReplaceCylindersWithCapsules)));
        ret.properties_.emplace("WorldLinkScale", Property("WorldLinkScale", false, boost::any(WorldLinkScale)));
        ret.properties_.emplace("RobotLinkScale", Property("RobotLinkScale", false, boost::any(RobotLinkScale)));
        ret.properties_.emplace("WorldLinkPadding", Property("WorldLinkPadding", false, boost::any(WorldLinkPadding)));
        ret.properties_.emplace("RobotLinkPadding", Property("RobotLinkPadding", false, boost::any(RobotLinkPadding)));
        ret.properties_.emplace("RobotLinkReplacementConfig", Property("RobotLinkReplacementConfig", false, boost::any(RobotLinkReplacementConfig)));
        return ret;
    }

    std::string Name;
    bool Debug;
    bool ReplacePrimitiveShapesWithMeshes;
    bool ReplaceCylindersWithCapsules;
    double WorldLinkScale;
    double RobotLinkScale;
    double WorldLinkPadding;
    double RobotLinkPadding;
    std::string RobotLinkReplacementConfig;
};

}

#include <exotica_core/exotica_core_initializers_numerator.h>


#endif